from PyQt4 import QtCore, QtGui

from core.auimd_widget import *

class FileOpenSave(QtGui.QFileDialog, AuimdWidget):
  def __init__(self, parent, type):
    QtGui.QFileDialog.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    self.loop=None
    self.selected_file=None

    if type==0:
      self.widget_title="Open..."
      self.widget_icon=QtGui.QIcon("core/icons/fileopen.png")
      self.left_button.setText("Open")
      self.right_button.setText("Cancel")
      self.setAcceptMode(QtGui.QFileDialog.AcceptOpen)
    elif type==1:
      self.widget_title="Save..."
      self.widget_icon=QtGui.QIcon("core/icons/filesave.png")
      self.left_button.setText("Save")
      self.right_button.setText("Cancel")
      self.setAcceptMode(QtGui.QFileDialog.AcceptSave)
    elif type==2:
      self.widget_title="Choose a directory..."
      self.widget_icon=QtGui.QIcon("core/icons/fileopen.png")
      self.left_button.setText("Open")
      self.right_button.setText("Cancel")
      self.setFileMode(QtGui.QFileDialog.DirectoryOnly)
      self.setAcceptMode(QtGui.QFileDialog.AcceptOpen)

    self.connect(self, QtCore.SIGNAL("accepted()"), self.leftButtonAction)
    self.connect(self, QtCore.SIGNAL("rejected()"), self.rightButtonAction)

  def openSaveFile(self):
    self.show()
    self.loop=QtCore.QEventLoop(self)
    self.loop.exec_()

    return self.selected_file

  def leftButtonAction(self):
    self.selected_file=str(self.selectedFiles()[0])
    self.loop.exit()

  def rightButtonAction(self):
    self.selected_file=None
    self.loop.exit()

  def closeEvent(self, e):
    if(self.loop): 
      self.selected_file=None
      self.loop.exit()
