import sys, traceback
from PyQt4 import QtCore, QtGui, uic

from core.auimd_widget import *

(Ui_Exception, BaseClass) = uic.loadUiType("core/widgets/ui/exception.ui")

class Exception(Ui_Exception, BaseClass, AuimdWidget):

  @staticmethod
  def defaultWidgetIcon():
    return QtGui.QIcon("core/widgets/icons/clanbomber.png")

  @staticmethod
  def defaultWidgetTitle():
    return "Exception"

  def __init__(self, parent, exc_value, exc_traceback):
    BaseClass.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    self.setupUi(self)
    
    self.setWidgetTitle(self.defaultWidgetTitle()+" - "+str(exc_value))
    tb_text="Error:\n"
    tb_text+=str(exc_value)+"\n\n"
    tb_text+="Traceback (most recent call last):\n"
    tb_text+="".join(traceback.format_tb(exc_traceback))
    self.exception_text.setPlainText(tb_text)
    self.right_button.setText("Close")
    self.send_bug_report.hide()

  def rightButtonAction(self):
    self.desktop.closeWidget(self)

