class BaseDevice:
  def __init__():
    pass

  def readValueFromFile(self, file):
    return int(open(file, "r").readline())

  def writeValueToFile(self, file, value):
    open(file, "w").write(str(value))

  def hasScreenBrightnessControl(self):
    """Return 1 if the device has support for setting the screen brightness."""
    return 0

  def hasScreenPowerControl(self):
    """Return 1 if the device has support for switching on/off the screen."""
    return 0
    
  def setScreenBrightness(self, val):
    """Set the brightness level between 0..100."""
    pass

  def getScreenBrightness(self):
    """Return the brightness level in the range 0..100, -1 in case of error."""
    return -1

  def setScreenPower(self, power):
    """Set the screen power status, 0=off, 1=on."""
    pass

  def getScreenPower(self):
    """Return the screen power status, 0=off, 1=on, -1 in case of error."""
    return -1

  def hasBatteryStatus(self):
    """Return 1 if the battery status is available."""
    return 0

  def getBatteryStatus(self):
    """Return the battery status as a tuple (level, state)
    
    level: between 0..100, -1 if not available
    state: 0=discharging, 1=charging, -1=not available
    """
    return (-1, -1)
