#!/usr/bin/env python

import sys

from PyQt4 import QtCore, QtGui


class X11Application(QtCore.QProcess):
  def __init__(self):
    QtCore.QProcess.__init__(self)

    self.containers=[]

    new_env=QtCore.QProcess.systemEnvironment()
    new_env.append("LD_PRELOAD=/home/pierrot/Devices/NFS/shared/pe/misc/x11-window-id/preload/x11-window-id.so")
    self.setEnvironment(new_env)
    self.setReadChannel(QtCore.QProcess.StandardError)
    self.setOpenMode(QtCore.QIODevice.ReadWrite)
    QtCore.QObject.connect(self, QtCore.SIGNAL("readyRead()"), self.tryReadWindowId)

  def tryReadWindowId(self):
    key="PE_X11_NEW_WINDOW"
    if self.bytesAvailable()>=len(key):
      d=self.read(len(key))
      if d==key:
        win_id=int(self.readLine())
        container=QtGui.QX11EmbedContainer()
        QtCore.QObject.connect(container, QtCore.SIGNAL("clientClosed()"), self.clientClosed)
        #QtCore.QThread.sleep(3)
        container.show()
        container.embedClient(win_id)
        self.containers.append(container)
      else:
        # discard remaining bytes
        self.readAll()

  def clientClosed(self):
    print "closing"
    #self.containers.remove(self.sender())
    self.sender().hide()
    #self.sender().deleteLater()
    
if __name__=="__main__":
  app=QtGui.QApplication(sys.argv)

  p=X11Application()
  p.start("gimp-2.3")

  app.exec_()
