from PyQt4 import QtCore, QtGui, uic

from . import __path__
from core.auimd_widget import *

(Ui_LookNFeel, BaseClass) = uic.loadUiType(__path__[0]+"/ui/looknfeel.ui")

class LookNFeel(Ui_LookNFeel, BaseClass, AuimdWidget):
  @staticmethod
  def defaultWidgetIcon():
    return QtGui.QIcon(__path__[0]+"/icons/looknfeel.png")

  @staticmethod
  def defaultWidgetTitle():
    return "Look And Feel"

  @staticmethod
  def getCategory():
    return "Settings"

  def __init__(self, parent):
    BaseClass.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    self.setupUi(self)

    QtCore.QObject.connect(self.styles, QtCore.SIGNAL("activated(const QString &)"), self.setStyle)
    QtCore.QObject.connect(self.wallpaper_select, QtCore.SIGNAL("clicked()"), self.selectWallpaper)

    self.styles.addItems(QtGui.QStyleFactory.keys())
    self.styles.setCurrentIndex(self.styles.findText(QtGui.qApp.style().objectName(), QtCore.Qt.MatchContains))

    wallpaper=self.desktop.getWallpaper()
    self.updateWallpaper(wallpaper.path, wallpaper.scaled)

    #self.left_button.setText("Apply")
    self.right_button.setText("Close")

  def setStyle(self, style):
    QtGui.qApp.setStyle(style)

  def selectWallpaper(self):
    file=self.desktop.openFile(self)
    self.desktop.setWallpaper(file, 0)
    self.updateWallpaper(file, 0)

  def updateWallpaper(self, path, scaled):
    self.wallpaper_path.setText(path)
    g=QtGui.QGraphicsScene(self)
    p=QtGui.QPixmap(path)
    r=g.addPixmap(p)
    self.wallpaper_view.setScene(g)
    self.wallpaper_view.show()
    self.wallpaper_view.fitInView(r, QtCore.Qt.KeepAspectRatioByExpanding)
#QtCore.QRectF(self.wallpaper_view.geometry()))

  def readyToClose(self):
    #m=QtGui.QMessageBox()
    #m.setFixedSize(240,100)
    #m.setMinimumSize(240,100)
    #m.setStandardButtons(QtGui.QMessageBox.Yes | QtGui.QMessageBox.No)
    #m.setInformativeText("Confirm quit ?")
    #m.setIcon(QtGui.QMessageBox.Question)
    #m.exec_()
    return 1

  #def leftButtonAction(self):
    #pass

  def rightButtonAction(self):
    self.desktop.closeWidget(self)
